# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2012-12-20.      #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for output of voltage between 0 and 5V
  class BrickletAnalogOut < Device

    FUNCTION_SET_VOLTAGE = 1 # :nodoc:
    FUNCTION_GET_VOLTAGE = 2 # :nodoc:
    FUNCTION_SET_MODE = 3 # :nodoc:
    FUNCTION_GET_MODE = 4 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt>. This object can
    # then be added to the IP connection.
    def initialize(uid)
      super uid

      @expected_name = 'Analog Out Bricklet'

      @binding_version = [1, 0, 0]

    end

    # Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
    # Calling this function will set the mode to 0 (see BrickletAnalogOut#set_mode).
    # 
    # The default value is 0 (with mode 1).
    def set_voltage(voltage)
      send_request(FUNCTION_SET_VOLTAGE, [voltage], 'S', 0, '')
    end

    # Returns the voltage as set by BrickletAnalogOut#set_voltage.
    def get_voltage
      send_request(FUNCTION_GET_VOLTAGE, [], '', 2, 'S')
    end

    # Sets the mode of the analog value. Possible modes:
    # 
    # * 0: Normal Mode (Analog value as set by BrickletAnalogOut#set_voltage is applied
    # * 1: 1k Ohm resistor to ground
    # * 2: 100k Ohm resistor to ground
    # * 3: 500k Ohm resistor to ground
    # 
    # Setting the mode to 0 will result in an output voltage of 0. You can jump
    # to a higher output voltage directly by calling BrickletAnalogOut#set_voltage.
    # 
    # The default mode is 1.
    def set_mode(mode)
      send_request(FUNCTION_SET_MODE, [mode], 'C', 0, '')
    end

    # Returns the mode as set by BrickletAnalogOut#set_mode.
    def get_mode
      send_request(FUNCTION_GET_MODE, [], '', 1, 'C')
    end

  end
end
